#include <cstdio>
#include <cstdlib>

//whether each query is echoed to screen 
static int _echo=1;

static int _bottle[10001];
static int _cap[10001];
static int _N;

static int _reported[10001],_total;

static int _initialized=0;
static int _query_count;

FILE *_f_in,*_f_out;

void quit(char *s){
  if(_echo){
    printf(s);
  }
  fprintf(_f_out,"%s",s);

  fclose(_f_out);
  exit(0);
}

int getN() {
  if(_initialized){
    quit("ERROR: already initialized");
  }

  _initialized=1;
  _query_count=0;

  _f_in=fopen("bottlecap.in","r");

  fscanf(_f_in,"%d",&_N);

  for(int i=0;i<_N;i++){
    fscanf(_f_in,"%d",&_cap[i]);
  }

  for(int i=0;i<_N;i++){
    fscanf(_f_in,"%d",&_bottle[i]);
  }

  fclose(_f_in);

  for(int i=0;i<_N;i++){
    _reported[i]=0; 
  }
  _total=0;

  if(_echo){
    printf("getN called, N=%d\n",_N);
  }

  _f_out=fopen("bottlecap.out","w");

  return _N;
}


int query(int capid,int bottleid){
  int _result;

  if(!_initialized){
    quit("Called query without initializing\n");
  }

  if( capid<1 || capid>_N || bottleid<1 || bottleid >_N){
    quit("Invalid id in query");
  }

  capid--;
  bottleid--;
  if(_query_count==500000){
    quit("Query limit exceeded\n");
  }

  if(_cap[capid]<_bottle[bottleid]){
    _result=-1;
  }
  else if(_cap[capid]==_bottle[bottleid]){
    _result=0;
  }
  else if(_cap[capid]>_bottle[bottleid]){
    _result=1;
  }

  if(_echo){
    printf("Query no.%d: cap %d %c bottle %d\n",_query_count,
      capid+1,(_result==-1)?'<':(_result==0)?'=':'>',bottleid+1);
  }
  _query_count++;

  return _result;
}

void report(int capid,int bottleid){
  if( capid<1 || capid>_N || bottleid<1 || bottleid >_N){
    quit("Invalid id in report");
  }

  if(_echo){
    printf("Reporting match betwen cap %d and bottle%d\n",capid,bottleid);
  }

  if(!_initialized){
    quit("Called report without initializing\n");
  }

  capid--;
  bottleid--;

  if(_reported[capid]==1){
    quit("Duplicated report\n");
  }
  _reported[capid]=1;

  if(_cap[capid]!=_bottle[bottleid]){
    quit("Mismatch\n");
  }

  _total++;
  if(_total==_N){
    quit("correct\n");
  }
}
