unit bottlecaplib;

interface
function getN:longint;
function query(capid: longint;bottleid: longint):longint;
procedure report(capid: longint;bottleid: longint);

implementation

const

  MAXN = 10001;
  _echo =1;

var
  _bottle,_cap: array [1..MAXN] of longint;
  _N,_total,_query_count: longint;
  _reported: array [1..MAXN] of boolean;
  _initialized: boolean;
  _f_in,_f_out: text;

procedure quit(s:string);
begin
  if _echo=1 then
    writeln(s);
  writeln(_f_out,s);
  close(_f_out);
end;

function getN():longint;
var
  i: longint;
begin
  if _initialized then
    quit('ERROR: already initialized');

  _initialized:=true;
  _query_count:=0;

  assign(_f_in,'bottlecap.in');
  reset(_f_in);

  read(_f_in,_N);

  for i:=1 to _N do
    read(_f_in,_cap[i]);

  for i:=1 to _N do
    read(_f_in,_bottle[i]);

  close(_f_in);

  for i:=1 to _N do
    _reported[i]:=false;

  _total:=0;

  if _echo=1 then
    writeln('getN called, N=',_N);

  assign(_f_out,'bottlecap.out');
  rewrite(_f_out);

  getN:=_N;
end;

function query(capid: longint;bottleid: longint):longint;
var
  _result:longint;
  ch:char;
begin
  if not _initialized then
    quit('Called query without initializing\n');

  if (capid<1) or (capid>_N) or (bottleid<1) or (bottleid>_N) then
    quit('Invalid id in query');

  if _query_count=500000 then
    quit('Query limit exceeded\n');

  if _cap[capid]<_bottle[bottleid] then
    begin
      _result:=-1;
      ch:='<';
    end
  else if _cap[capid]=_bottle[bottleid] then
    begin
      _result:=0;
      ch:='=';
    end
  else if _cap[capid]>_bottle[bottleid] then
    begin
      _result:=1;
      ch:='>';
    end;
  
  inc(_query_count);

  if _echo=1 then
    writeln('Query no.',_query_count,': cap ',capid,' ',ch,' bottle ',bottleid);

  query:=_result;
end;

procedure report(capid: longint;bottleid: longint);
begin
  if (capid<1) or (capid>_N) or (bottleid<1) or (bottleid>_N) then
    quit('Invalid id in report');

  if _echo=1 then
    writeln('Reporting match betwen cap ',capid,' and bottle ',bottleid);
  
  if not _initialized then
    quit('Called report without initializing\n');

  if _reported[capid] then
    quit('Duplicated report\n');

  _reported[capid]:=true;

  if _cap[capid]<>_bottle[bottleid] then
    quit('Mismatch');

  inc(_total);
  if _total=_N then
    quit('correct');
end;

begin
  _initialized := false;
end.

